from java.awt import Component
from java.awt.image import BufferedImage
from java.lang import Object
from typing import Optional

class INavUtilities:
    def centerWindow(self, arg) -> None: ...
    def closeParentWindow(self, event) -> None: ...
    def closeWindow(self, arg) -> None: ...
    def getCurrentWindow(self) -> None: ...
    def goBack(self) -> None: ...
    def goForward(self) -> None: ...
    def goHome(self) -> None: ...
    def openWindow(self, *args) -> None: ...
    def openWindowImpl(self, path, params, openAdditional) -> None: ...
    def openWindowInstance(self, *args) -> None: ...
    def swapTo(self, *args) -> None: ...
    def swapWindow(self, *args) -> None: ...

class NavUtilities(INavUtilities):
    def centerWindow(self, arg) -> None: ...
    def closeParentWindow(self, event) -> None: ...
    def closeWindow(self, arg) -> None: ...
    def getCurrentWindow(self) -> None: ...
    def goBack(self) -> None: ...
    def goForward(self) -> None: ...
    def goHome(self) -> None: ...
    def openWindow(self, *args) -> None: ...
    def openWindowImpl(self, path, params, openAdditional) -> None: ...
    def openWindowInstance(self, *args) -> None: ...
    def swapTo(self, *args) -> None: ...
    def swapWindow(self, *args) -> None: ...

class PrintUtilities(Object):
    def __init__(self, app) -> None: ...
    def createImage(self, c: Component) -> BufferedImage: ...
    def createPrintJob(self, c: Component) -> PrintUtilities.JythonPrintJob: ...
    def printToImage(self, c: Component, fileName: Optional[str] = ...) -> None: ...
    class JythonPrintJob(Object):
        def getBottomMargin(self) -> None: ...
        def getLeftMargin(self) -> None: ...
        def getOrientation(self) -> None: ...
        def getPageHeight(self) -> None: ...
        def getPageWidth(self) -> None: ...
        def getPrinterName(self) -> None: ...
        def getRightMargin(self) -> None: ...
        def getTopMargin(self) -> None: ...
        def getZoomFactor(self) -> None: ...
        def isFitToPage(self) -> None: ...
        def isShowPrintDialog(self) -> None: ...
        def setBottomMargin(self, bottomMargin) -> None: ...
        def setFitToPage(self, fitToPage) -> None: ...
        def setLeftMargin(self, leftMargin) -> None: ...
        def setMargins(self, m) -> None: ...
        def setOrientation(self, orientation) -> None: ...
        def setPageHeight(self, pageHeight) -> None: ...
        def setPageWidth(self, pageWidth) -> None: ...
        def setPrinterName(self, printerName) -> None: ...
        def setRightMargin(self, rightMargin) -> None: ...
        def setShowPrintDialog(self, showPrintDialog) -> None: ...
        def setZoomFactor(self, zoomFactor) -> None: ...

class WindowUtilities(Object):
    def confirm(self, *args) -> None: ...
    def errorBox(self, *args) -> None: ...
    def inputBox(self, *args) -> None: ...
    def messageBox(self, *args) -> None: ...
    def passwordBox(self, *args) -> None: ...
    def warningBox(self, *args) -> None: ...
