from java.lang import Iterable
from org.python.core import PyObject

class AlarmEvent(Iterable):
    def acknowledge(self, ackData) -> None: ...
    def active(self, activeData) -> None: ...
    def clear(self, clearData) -> None: ...
    def getAckData(self) -> None: ...
    def getActiveData(self) -> None: ...
    def getClearedData(self) -> None: ...
    def getDisplayPath(self) -> None: ...
    def getId(self) -> None: ...
    def getLabel(self) -> None: ...
    def getLastEventState(self) -> None: ...
    def getName(self) -> None: ...
    def getNotes(self) -> None: ...
    def getPriority(self) -> None: ...
    def getSource(self) -> None: ...
    def getState(self) -> None: ...
    def isAcked(self) -> None: ...
    def isCleared(self) -> None: ...
    def isShelved(self) -> None: ...
    def iterator(self) -> None: ...

class PyAlarmEvent(AlarmEvent):
    def acknowledge(self, ackData) -> None: ...
    def active(self, activeData) -> None: ...
    def clear(self, clearData) -> None: ...
    def contains(self, property) -> None: ...
    def get(self, property) -> None: ...
    def getAckData(self) -> None: ...
    def getActiveData(self) -> None: ...
    def getClearedData(self) -> None: ...
    def getDisplayPath(self) -> None: ...
    def getId(self) -> None: ...
    def getLabel(self) -> None: ...
    def getLastEventState(self) -> None: ...
    def getName(self) -> None: ...
    def getNotes(self) -> None: ...
    def getOrDefault(self, property) -> None: ...
    def getOrElse(self, property, defaultValue) -> None: ...
    def getPriority(self) -> None: ...
    def getSource(self) -> None: ...
    def getState(self) -> None: ...
    def isAcked(self) -> None: ...
    def isCleared(self) -> None: ...
    def isShelved(self) -> None: ...
    def set(self, property, value) -> None: ...
    def setGlobal(self, property, value) -> None: ...
    def sourceEvent(self) -> None: ...

class PyAlarmEventImpl(PyAlarmEvent, PyObject):
    def __init__(self, event) -> None: ...
    def contains(self, property) -> None: ...
    def get(self, property) -> None: ...
    def getOrDefault(self, property) -> None: ...
    def getOrElse(self, property, defaultValue) -> None: ...
    def set(self, property, value) -> None: ...
    def setGlobal(self, property, value) -> None: ...
    def sourceEvent(self) -> None: ...
